BulkyBookWeb/Models/Category.cs
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace BulkyBookWeb.Models
{
    public class Category
    {
        [Key]
        public int Id { get; set; }
        [Required]
        public string Name { get; set; }
        [DisplayName("Display Order")]
        [Range(1,100,ErrorMessage="Display order must be between 1 and 100!")]
        public int DisplayOrder { get; set; }
        public DateTime CreatedDateTime { get; set; } = DateTime.Now;
    }
}

BulkyBookWeb/Models/ErrorViewModel.cs
namespace BulkyBookWeb.Models
{
    public class ErrorViewModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

BulkyBookWeb/Controllers/CategoryController.cs
using BulkyBookWeb.Data;
using BulkyBookWeb.Models;
using Microsoft.AspNetCore.Mvc;

namespace BulkyBookWeb.Controllers
{
    public class CategoryController : Controller
    {

        private readonly ApplicationDbContext _db;

        public CategoryController(ApplicationDbContext db)
        {
            _db = db;
        }

        public IActionResult Index()
        {
            IEnumerable<Category> objCategoryList = _db.Categories;
            return View(objCategoryList);
        }

        //GET
        public IActionResult Create()
        {
            return View();
        }

        //POST
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(Category obj)
        {
            if(obj.Name == obj.DisplayOrder.ToString())
            {
                ModelState.AddModelError("CustomError","Display Order cannot match with the name");
            }
            if(int.TryParse(obj.Name,out _))
            {
                ModelState.AddModelError("CustomError", "Name can not be a number");

            }
            if (ModelState.IsValid)
            {
                _db.Categories.Add(obj);
                _db.SaveChanges();
                TempData["success"] = "Category created successfully";
                return RedirectToAction("Index");
            }
            return View(obj);
        }

        //GET
        public IActionResult Edit(int? id)
        {
            if(id == null || id == 0)
            {
                return NotFound();  
            }
            var categoryFromDb = _db.Categories.Find(id);
            if(categoryFromDb == null)
            {
                return NotFound();
            }
            return View(categoryFromDb);
        }

        //POST
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(Category obj)
        {
            if (obj.Name == obj.DisplayOrder.ToString())
            {
                ModelState.AddModelError("CustomError", "Display Order cannot match with the name");
            }
            if (int.TryParse(obj.Name, out _))
            {
                ModelState.AddModelError("CustomError", "Name can not be a number");

            }
            if (ModelState.IsValid)
            {
                _db.Categories.Update(obj);
                _db.SaveChanges();
                TempData["success"] = "Category edited successfully";
                return RedirectToAction("Index");
            }
            return View(obj);
        }

        //GET
        public IActionResult Delete(int? id)
        {
            if (id == null || id == 0)
            {
                return NotFound();
            }
            var categoryFromDb = _db.Categories.Find(id);
            if (categoryFromDb == null)
            {
                return NotFound();
            }
            return View(categoryFromDb);
        }

        //POST
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult DeletePOST(int? id)
        {
            var obj = _db.Categories.Find(id);

            if(obj == null)
            {
                return NotFound();
            }

            _db.Categories.Remove(obj);
            _db.SaveChanges();
            TempData["success"] = "Category deleted successfully";
            return RedirectToAction("Index");

        }
    }
}

BulkyBookWeb/Controllers/HomeController.cs
using BulkyBookWeb.Models;
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;

namespace BulkyBookWeb.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

BulkyBookWeb/Views/Category/Create.cshtml
@model Category

<form method="post">
	<div class="border p-3 mt-4">
		<div class="row pb-2">
			<h2 class="text-primary">Create Category</h2>
			<hr />
		</div>
		<div class="mb-3">
			<label asp-for="Name">Name</label>
			<input asp-for="Name" class="form-control" />
			<span asp-validation-for="Name" class="text-danger"></span>
		</div>
		<div class="mb-3">
			<label asp-for="DisplayOrder">Display Order</label>
			<input asp-for="DisplayOrder" class="form-control" />
			<span asp-validation-for="DisplayOrder" class="text-danger"></span>

		</div>
		<button type="submit" class="btn btn-primary" style="width:150px">
			Create
		</button>
		<a asp-controller="Category" asp-action="Index" class="btn btn-secondary" style="width:150px">
			Back to list
		</a>
	</div>

</form>

@section Scripts {
	@{
		<partial name="_ValidationScriptsPartial" />
	}
}

BulkyBookWeb/Views/Category/Delete.cshtml
@model Category

<form method="post" asp-action="DeletePOST">
	<input asp-for="Id" hidden/>
	<div class="border p-3 mt-4">
		<div class="row pb-2">
			<h2 class="text-primary">Edit Category</h2>
			<hr />
		</div>
		<div class="mb-3">
			<label asp-for="Name">Name</label>
			<input asp-for="Name" class="form-control" disabled />
			<span asp-validation-for="Name" class="text-danger"></span>
		</div>
		<div class="mb-3">
			<label asp-for="DisplayOrder">Display Order</label>
			<input asp-for="DisplayOrder" class="form-control" disabled/>
			<span asp-validation-for="DisplayOrder" class="text-danger"></span>

		</div>
		<button type="submit" class="btn btn-danger" style="width:150px">
			Delete
		</button>
		<a asp-controller="Category" asp-action="Index" class="btn btn-secondary" style="width:150px">
			Back to list
		</a>
	</div>

</form>

@section Scripts {
	@{
		<partial name="_ValidationScriptsPartial" />
	}
}

BulkyBookWeb/Views/Category/Edit.cshtml
@model Category

<form method="post" asp-action="Edit">
	<div class="border p-3 mt-4">
		<div class="row pb-2">
			<h2 class="text-primary">Edit Category</h2>
			<hr />
		</div>
		<div class="mb-3">
			<label asp-for="Name">Name</label>
			<input asp-for="Name" class="form-control" />
			<span asp-validation-for="Name" class="text-danger"></span>
		</div>
		<div class="mb-3">
			<label asp-for="DisplayOrder">Display Order</label>
			<input asp-for="DisplayOrder" class="form-control" />
			<span asp-validation-for="DisplayOrder" class="text-danger"></span>

		</div>
		<button type="submit" class="btn btn-primary" style="width:150px">
			Update
		</button>
		<a asp-controller="Category" asp-action="Index" class="btn btn-secondary" style="width:150px">
			Back to list
		</a>
	</div>

</form>

@section Scripts {
	@{
		<partial name="_ValidationScriptsPartial" />
	}
}

BulkyBookWeb/Views/Category/Index.cshtml
@model IEnumerable<Category>
@{
    ViewData["Title"] = "Index";
}


<br /><br />
<h1>Index Category</h1>

<div class="container p-3">
   <div class="row pt-4">
        <div class="col-6">
            <h2 class="text-primary">Category List</h2>
        </div>
        <div class="col-6 text-end">
            <a asp-controller="Category" asp-action="Create" class="btn btn-primary">
                <i class="bi bi-plus-circle"></i> &nbsp; New Category
            </a>
        </div>
   </div>
</div>

<table class="table table-bordered table-striped" style="width:100%">
    <thead>
        <tr>
            <th>
                Category Name
            </th>
            <th>
                Display Order
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach(var obj in Model){
            <tr>
                <td>
                    @obj.Name
                </td>
                <td>
                    @obj.DisplayOrder
                </td>
                <td>
                    <div class="w-75 btn-group" role="group">
                        <a asp-controller="Category" asp-action="Edit" asp-route-id="@obj.Id"
                        class="btn btn-primary mx-1"><i class="bi bi-pencil-square"></i>Edit</a>
                        <a asp-controller="Category" asp-action="Delete" asp-route-id="@obj.Id"
                       class="btn btn-danger mx-1"><i class="bi bi-trash"></i>Delete</a>
                    </div>
                </td>
            </tr>  
        }
    </tbody>
</table>

BulkyBookWeb/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

BulkyBookWeb/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - BulkyBookWeb</title>
    <link rel="stylesheet" href="~/css/bootswatchTheme.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/BulkyBookWeb.styles.css" asp-append-version="true" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.3.0/font/bootstrap-icons.css">
    <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
            <div class="container-fluid">
                <a class="navbar-brand" asp-controller="Home" asp-action="Index">Bulky Book</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor02" aria-controls="navbarColor02" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarColor02">
                    <ul class="navbar-nav me-auto">
                        <li class="nav-item">
                            <a class="nav-link" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-light" asp-area="" asp-controller="Category" asp-action="Index">Category</a>
                        </li>
                    </ul>
                    <form class="d-flex">
                        <input class="form-control me-sm-2" type="text" placeholder="Search">
                        <button class="btn btn-secondary my-2 my-sm-0" type="submit">Search</button>
                    </form>
                </div>
            </div>
        </nav>
    </header>

    <div class="container">
        <main role="main" class="pb-3">
            <partial name="_Notification" />
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2022 - BulkyBookWeb - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.1/dist/js/bootstrap.min.js" integrity="sha384-7VPbUDkoPSGFnVtYi0QogXtr74QeVeeIs99Qfg5YCF+TidwNdjvaKZX19NZ/e6oz" crossorigin="anonymous"></script>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

BulkyBookWeb/Views/Shared/_Notification.cshtml
@if (TempData["success"] != null)
{
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>
    <script type="text/javascript">
        toastr.success('@TempData["success"]');
    </script>
}
@if (TempData["error"] != null)
{
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>
    <script type="text/javascript">
        toastr.error('@TempData["error"]');
    </script>
    <h2>@TempData["error"]</h2>
}